<?php

use Budget\Entity\Expense;

$gbcpExpenseTypes = [];

foreach ($this->expenseTypes as $type) {
	if (!in_array($type, [
		Expense::TYPE_AE,
		Expense::TYPE_AE_COMMITTED,
		Expense::TYPE_AE_ESTIMATED,
		Expense::TYPE_CP,
		Expense::TYPE_CP_COMMITTED,
		Expense::TYPE_CP_ESTIMATED,
	])) {
		continue;
	}

	$gbcpExpenseTypes[] = $type;
}

?>

<div ng-controller="gbcpController as self" ng-init="self.initQueries()">
	<table-builder options="self.options" class="table-builder">
		<div class="row">
			<div class="col-md-4">
				<table-builder-columns></table-builder-columns>
			</div>

			<?php if ($this->acl()->isAllowed('application:e:query:r')): ?>
				<div class="col-md-4 col-md-offset-4">
					<div class="queries-toggler little-panel">
						<div href="#queries-collapsed-node-tree-gbcp"
						     data-toggle="collapse"
						     class="title">
							<i class="fa fa-shopping-basket fa-fw"></i>
							Requêtes
						</div>

						<div id="queries-collapsed-node-tree-gbcp"
						     class="body collapse">
							<div ng-if="self.loadingQueries"
							     class="text-center">
								<i class="fa fa-spin fa-circle-o-notch"></i>
							</div>

							<ul class="list-unstyled">
								<li ng-repeat="query in self.queries">
									<a ng-click="self.loadQuery(query)"
									   class="pointer">
										<i ng-if="query.shared" class="fa fa-share-alt"></i> {{ query.name }}
									</a>

									<i ng-click="self.deleteQuery(query)" ng-if="query._rights.delete"
									   tooltip="Supprimer"
									   class="fa fa-trash pointer pull-right">
									</i>
								</li>
							</ul>

							<form ng-submit="self.saveQuery()"
							      name="queryForm">
								<div class="input-group input-group-sm">
									<input ng-model="self.query.name"
									       placeholder="Nom de la requête"
									       type="text"
									       class="form-control"
									       required/>

									<span class="input-group-btn">
										<label class="checkbox-inline" style="margin: 0 10px">
											<input type="checkbox" ng-model="self.query.shared"/>
											Partagée ?
										</label>

										<button ng-disabled="self.loadingSaveQuery"
										        type="submit"
										        class="btn btn-submit">
											<i ng-if="self.loadingSaveQuery"
											   class="fa fa-spin fa-circle-o-notch">
											</i>
											Enregistrer
										</button>
									</span>
								</div>

								<field-errors field="name"
								              errors="errors.fields">
								</field-errors>
							</form>
						</div>
					</div>
				</div>
			<?php endif ?>

		</div>
		<div class="row">
			<div class="col-md-4">
				<div ng-controller="filterController as filter"
				     class="table-filters little-panel">
					<div class="title" data-toggle="collapse" href="#filters-collapsed-gbcp-poste-expenses">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
						<?= ucfirst($this->translate('poste_expense_entity')) ?>
					</div>
					<div id="filters-collapsed-gbcp-poste-expenses" class="body collapse">
						<?= $this->tableFilter('self.filters.posteExpense', $this->posteExpenseFilters()); ?>
					</div>
				</div>
			</div>

			<div class="col-md-4">
				<div ng-controller="projectFilterController as filter"
				     ng-init="filter.init(self.filters.project)"
				     class="table-filters little-panel">
					<div class="title" data-toggle="collapse" href="#filters-collapsed-gbcp-project">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
						<?= ucfirst($this->translate('project_entity')) ?>
					</div>
					<div id="filters-collapsed-gbcp-project" class="body collapse project">
						<?= $this->tableFilter('self.filters.project', $this->projectFilters()); ?>
					</div>
				</div>
			</div>

			<div class="col-md-4">
				<div ng-controller="filterController as filter"
				     class="table-filters little-panel">
					<div class="title" data-toggle="collapse" href="#filters-collapsed-gbcp-poste-incomes">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
						<?= ucfirst($this->translate('poste_income_entity')) ?>
					</div>
					<div id="filters-collapsed-gbcp-poste-incomes" class="body collapse">
						<?= $this->tableFilter('self.filters.posteIncome', $this->posteIncomeFilters()); ?>
					</div>
				</div>
			</div>
		</div>

		<div class="row">
			<div class="col-md-4">
				<div ng-controller="filterController as filter"
				     class="table-filters little-panel">
					<div class="title" data-toggle="collapse" href="#filters-collapsed-gbcp-expense">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
						<?= ucfirst($this->translate('expense_entity')) ?>
					</div>
					<div id="filters-collapsed-gbcp-expense" class="body collapse">
						<?= $this->tableFilter('self.filters.expense', $this->expenseFilters()); ?>
					</div>
				</div>
			</div>

			<div class="col-md-4">
				<div class="row">
					<div class="col-xs-6">
						<button class="btn" ng-click="self.resetFilters();">
							<?= $this->translate('table_filter_reset_button') ?>
						</button>
					</div>
					<div class="col-xs-6 text-right">
						<button class="btn" ng-click="self.applyFilters();">
							<?= $this->icon('search', 'fa-fw') ?>
							<?= $this->translate('table_filter_button') ?>
						</button>
					</div>
				</div>
			</div>

			<div class="col-md-4">
				<div ng-controller="filterController as filter"
				     class="table-filters little-panel">
					<div class="title" data-toggle="collapse" href="#filters-collapsed-gbcp-income">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
						<?= ucfirst($this->translate('income_entity')) ?>
					</div>
					<div id="filters-collapsed-gbcp-income" class="body collapse">
						<?= $this->tableFilter('self.filters.income', $this->incomeFilters()); ?>
					</div>
				</div>
			</div>
		</div>

		<div class="row separator" ng-if="self.loading">
			<div class="col-xs-12 text-center">
				<?= $this->icon('loading') ?>
			</div>
		</div>

		<div class="row">
			<div class="col-sm-12">
				<div class="pull-left">
					{{ self.rows.length }} lignes
				</div>
				<div class="btn-group pull-right">
					<button
						class="btn btn-excel"
						type="button"
						ng-click="self.export()"
						tooltip="<?= $this->translate('tooltip_export_xls') ?>"
					>
						<?= $this->icon('excel', 'fa-fw pointer') ?>
					</button>
				</div>
			</div>
		</div>

		<div class="row">
			<div class="col-xs-12">
				<div class="table-scroller">
					<table table-builder-table class="table table-bordered table-condensed table-hover">
						<thead>
							<tr>
								<th
									tb-column
									tb-name="tree"
									class="checkbox-column"
								></th>

								<th
									tb-column
									tb-name="project.code"
									tb-sortable="false"
									tb-toggle="true"
								>
									<?= ucfirst($this->translate('project_field_code')) ?>
								</th>

								<th
									tb-column
									tb-name="project.name"
									tb-sortable="false"
									tb-toggle="true"
								>
									<?= ucfirst($this->translate('project_entity')) ?>
								</th>

								<th
									tb-column
									tb-name="nature.name"
									tb-sortable="false"
									tb-toggle="true"
								>
									<?= ucfirst($this->translate('nature_entity')) ?>
								</th>

								<th
									tb-column
									tb-name="organization.name"
									tb-sortable="false"
									tb-toggle="true"
								>
									<?= ucfirst($this->translate('organization_entity')) ?>
								</th>

								<th
									tb-column
									tb-name="destination.name"
									tb-sortable="false"
									tb-toggle="true"
								>
									<?= ucfirst($this->translate('destination_entity')) ?>
								</th>

								<th
									tb-column
									tb-name="transaction.poste.name"
									tb-sortable="false"
									tb-toggle="true"
								>
									<?= ucfirst($this->translate('poste_entity')) ?>
								</th>

								<th
									tb-column
									tb-name="transaction.name"
									tb-sortable="false"
									tb-toggle="true"
								>
									<?= ucfirst($this->translate('transaction_entity')) ?>
								</th>

								<?php foreach ($gbcpExpenseTypes as $type): ?>
									<th
										tb-column
										tb-name="transaction.type.<?= $type ?>"
										tb-sortable="false"
										tb-toggle="true"
									>
										<?= $this->translate("expense_type_$type") ?>
									</th>

									<?php if ($this->ht): ?>
										<th
											tb-column
											tb-name="transaction.type.<?= $type ?>_ht"
											tb-sortable="false"
											tb-toggle="true"
											tb-hidden="true"
										>
											<?= $this->translate("expense_type_{$type}_ht") ?>
										</th>
									<?php endif ?>
								<?php endforeach ?>

								<th
									tb-column
									tb-name="transaction.type.income"
									tb-sortable="false"
									tb-toggle="true"
								>
									<?= ucfirst($this->translate('income_entity')) ?>
								</th>

								<?php if ($this->ht): ?>
									<th
										tb-column
										tb-name="transaction.type.income_ht"
										tb-sortable="false"
										tb-toggle="true"
										tb-hidden="true"
									>
										<?= ucfirst($this->translate('income_entity_ht')) ?>
									</th>
								<?php endif ?>
							</tr>
						</thead>
						<tbody>
							<tr
								ng-repeat-start="row in self.rows"
								ng-click="row.open = !row.open"
								class="group pointer"
							>
								<td>
									<i class="fa" ng-class="{
                                    'fa-caret-right': !row.open,
                                    'fa-caret-down': row.open
                                }"></i>
								</td>

								<td>
									{{ row.project.code }}
								</td>

								<td>
									<a href="<?= $this->url('project/form') ?>/{{ row.project.id }}">
										{{ row.project.name }}
									</a>
								</td>

								<td>
									<a href="<?= $this->url('budget/nature/form') ?>/{{ row.nature.id }}">
										{{ row.nature.name }}
									</a>
								</td>

								<td>
									<a href="<?= $this->url('budget/organization/form') ?>/{{ row.organization.id }}">
										{{ row.organization.name }}
									</a>
								</td>

								<td>
									<a href="<?= $this->url('budget/destination/form') ?>/{{ row.destination.id }}">
										{{ row.destination.name }}
									</a>
								</td>

								<td></td>
								<td></td>

								<?php foreach ($gbcpExpenseTypes as $type): ?>
									<td class="text-right">
										{{ row.total.<?= $type ?> | currency : '' }} €
									</td>

									<?php if ($this->ht): ?>
										<td class="text-right">
											{{ row.total.<?= $type ?>_ht | currency : '' }} €
										</td>
									<?php endif ?>
								<?php endforeach ?>

								<td class="text-right">
									{{ row.total.income | currency : '' }} €
								</td>


								<?php if ($this->ht): ?>
									<td class="text-right">
										{{ row.total.income_ht | currency : '' }} €
									</td>
								<?php endif ?>
							</tr>

							<tr
								ng-repeat="transaction in row.transactions"
								ng-show="row.open"
								class="sub-group pointer"
							>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>

								<td>
									{{ transaction.poste.name }}
								</td>

								<td>
									{{ transaction.name }}
								</td>

								<?php foreach ($gbcpExpenseTypes as $type): ?>
									<td class="text-right">
										<span ng-if="transaction.type === '<?= $type ?>'">
											{{ transaction.amount | currency : '' }} €
										</span>
									</td>

									<?php if ($this->ht): ?>
										<td class="text-right">
											<span ng-if="transaction.type === '<?= $type ?>'">
												{{ transaction.amountHT | currency : '' }} €
											</span>
										</td>
									<?php endif ?>
								<?php endforeach ?>

								<td class="text-right">
									<span ng-if="transaction.type === 'income'">
										{{ transaction.amount | currency : '' }} €
									</span>
								</td>

								<?php if ($this->ht): ?>
									<td class="text-right">
										<span ng-if="transaction.type === 'income'">
											{{ transaction.amountHT | currency : '' }} €
										</span>
									</td>
								<?php endif ?>
							</tr>

							<tr ng-repeat-end ng-if="false"></tr>
						</tbody>
						<tfoot>
							<tr class="footer">
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>

								<?php foreach ($gbcpExpenseTypes as $type): ?>
									<td class="text-right">
										{{ self.getTotal('<?= $type ?>') || 0 | currency : '' }} €
									</td>

									<?php if ($this->ht): ?>
										<td class="text-right">
											{{ self.getTotal('<?= $type ?>_ht') || 0 | currency : '' }} €
										</td>
									<?php endif ?>
								<?php endforeach ?>

								<td class="text-right">
									{{ self.getTotal('income') || 0 | currency : '' }} €
								</td>

								<?php if ($this->ht): ?>
									<td class="text-right">
										{{ self.getTotal('income_ht') || 0 | currency : '' }} €
									</td>
								<?php endif ?>
							</tr>
						</tfoot>
					</table>
				</div>
			</div>
		</div>
	</table-builder>
</div>
